; CONSOLE #
include win64a.inc
MAXSCREENX = 30
MAXSCREENY = 23
.code
WinMain	proc
local dithers:dword
local ConsoleWindow:SMALL_RECT
local Result:dword 
local MOUSE_KEY:INPUT_RECORD
local cci:CONSOLE_CURSOR_INFO

       	invoke	FreeConsole
       	invoke	AllocConsole
	invoke	GetStdHandle,STD_INPUT_HANDLE
	mov	hIn,rax
	invoke	GetStdHandle,STD_OUTPUT_HANDLE
	mov	hOut, rax
	invoke	GetLargestConsoleWindowSize,rax
;	eax return in 31-16 bits: dwCoord.y
;	              15-00 bits: dwCoord.x
	lea	r8d,ConsoleWindow
	mov	dword ptr [r8],0
;	ConsoleWindow.Left = 0 ConsoleWindow.Top = 0
	sub	ax, MAXSCREENX
	sbb	edx, edx
	and	ax, dx
	add	ax, MAXSCREENX-1
	mov	[r8+SMALL_RECT.Right],ax

	shr	eax, 16
	sub	eax, MAXSCREENY
	sbb	edx, edx
	and	eax, edx
	add	eax, MAXSCREENY-1
	mov	[r8+SMALL_RECT.Bottom],ax
	invoke	SetConsoleWindowInfo,hOut,TRUE
	invoke	SetConsoleScreenBufferSize,hOut,MAXSCREENY*10000h+MAXSCREENX
	invoke	SetConsoleTitle,&windowTitle
; ----------------------------------------
    	invoke  GetConsoleCursorInfo,hOut,&cci
        lea 	edx,cci             ; lpConsoleCursorInfo
    	mov 	[rdx+CONSOLE_CURSOR_INFO.bVisible],FALSE
    	invoke  SetConsoleCursorInfo,hOut
;decompressData--------------------------------------
	mov	esi,offset compSmallIcon	;in
        mov	edi,offset bmpSmallIcon         ;out
	xor	ecx,ecx
@6:	lodsb 			; int x = in[ f++ ]
	cmp	al,91h		; if ( x == 0x91 )
	jnz	@f
	lodsw
	mov	cl,ah
	jecxz	@7
	rep	stosb
	jmp	@7
@@:	stosb			; in[ t++ ] = x  
@7:	cmp	edi,offset bmpSmallIcon+MAXSCREENX*MAXSCREENY
	jnz	@6
;---------------------------------------------------
	mov	edi,8        ; int c = 0
	mov	dword ptr dithers, 176+(177+(178+219*100h)*100h)*100h

@1:	mov	edx,7		; int b=0

@2:	cmp	edx, 3		; if (b>3) 
	mov	ecx, edi        ; colour = c
	jbe	@f		; if (b==5 || b==3) colour|=((colour&7)<<4);
	or	ecx,FOREGROUND_INTENSITY; colour |= FOREGROUND_INTENSITY
 
@@:	cmp	edx, 5		; if (b==5 || b==3) 
	jz	@f
	cmp	edx, 3
	jnz	@3

@@:	mov	eax, ecx
	and	eax, 7          ;colour & 7
	shl	eax, 4          ;(colour & 7) << 4
	or	ecx, eax        ;colour |= ((colour&7) << 4)

@3:	test	edx, edx			; if (b==0) 
	jnz	@f
	xor	ecx, ecx        		; colour = 0

@@:	lea	eax, [rdx+rdi*8]		; eax = b + c * 8
	shl	eax, 2          		; eax =(b + c * 8)*4
	mov	palette.Attributes[rax],cx 	; palette[c][b].Attributes = colour;
	mov	ecx, edx                        ; ecx = b
	shr	ecx,1				; ecx = b >> 1
	mov	cl,byte ptr dithers[rcx]        ; cl = dithers[b >> 1]
	mov	palette.Char.AsciiChar[rax],cl  ; palette[c][b].Char.AsciiChar	= dithers[b>>1];
	dec	edx
	jns	@2
	dec	edi
	jnz 	@1
;---------------------------------------------------------------------------------
	;for (int x=0; x<MAXSCREENX; x++)
	mov	edi,offset chars
	mov	esi,offset bmpSmallIcon
@0:	push	rsi
	push	rdi
	mov	ecx, MAXSCREENY;for (int y=0; y<MAXSCREENY; y++)
@@:	lodsb	      ;al=pixel xxbbbccc   bbb = brightness ccc = colour
;getPalette(int pixel)
        shl eax,5 	;000xxbbb|ccc00000
        shl ah,2        ;0xxbbb00|ccc00000
        and eax,1CE0h   ;000bbb00|ccc00000
	add al,ah       ;000bbb00|cccbbb00
	and eax,0FFh    ;00000000|cccbbb00
	mov	eax, dword ptr palette[rax]; palette[colour][brightness]
	stosd	
	add	esi, MAXSCREENX-1
	add	edi, 320-4;
	loop 	@b
	pop	rdi
	pop	rsi
	add	edi,4
	inc	esi
	cmp	esi,offset bmpSmallIcon+MAXSCREENX
	jb	@0

; copyBufferToScreen()
	invoke	WriteConsoleOutput,hOut,&chars,320050h,0,&write
@@:     invoke	ReadConsoleInput,hIn,&MOUSE_KEY,TRUE,&Result
	lea	eax,MOUSE_KEY
	cmp 	[rax+INPUT_RECORD.EventType],KEY_EVENT
	jne 	@b
	cmp 	[rax+INPUT_RECORD.KeyEvent.wVirtualKeyCode],VK_ESCAPE
	jne 	@b
	invoke	CloseHandle,hIn
	invoke	CloseHandle,hOut
	invoke FreeConsole
	invoke	RtlExitUserProcess,NULL
WinMain	endp
hOut	dq ?
hIn	dq ?
compSmallIcon db 145, 0, 44, 63, 145, 0, 28, 63, 47, 63, 145, 0, 27, 63, 23, 63, 23, 145, 0, 25, 63, 47, 16, 0, 63, 145, 0, 25, 63, 23, 0, 0, 15, 63, 145, 0, 23, 63, 15, 145, 0, 4, 63, 23, 145, 0, 21
	db 63, 47, 16, 145, 0, 4, 23, 63, 145, 0, 21, 63, 23, 145, 0, 6, 15, 63, 145, 0, 19, 63, 55, 145, 0, 8, 63, 23, 60, 60, 52, 36, 28, 12, 145, 0, 12, 63, 31, 0, 0, 8, 145, 0, 5, 23, 63, 145, 60
	db 6, 52, 44, 36, 145, 0, 7, 15, 145, 63, 5, 15, 145, 0, 6, 63, 54, 54, 145, 62, 3, 54, 145, 38, 3, 0, 0, 15, 145, 63, 6, 145, 0, 5, 8, 145, 0, 6, 63, 59, 59, 51, 51, 58, 38, 46, 54, 145, 63
	db 3, 16, 145, 0, 3, 63, 31, 145, 0, 12, 23, 63, 45, 51, 59, 59, 51, 51, 58, 145, 0, 6, 63, 23, 145, 0, 14, 63, 48, 145, 37, 3, 53, 45, 59, 145, 0, 6, 63, 7, 145, 0, 14, 31, 63, 145, 0, 3, 37
	db 37, 45, 145, 0, 5, 63, 31, 145, 0, 16, 23, 63, 145, 0, 4, 37, 145, 0, 4, 63, 55, 145, 0, 18, 63, 48, 145, 0, 8, 63, 39, 145, 0, 18, 31, 63, 145, 0, 7, 63, 31, 8, 145, 0, 19, 23, 63, 145, 0
	db 5, 16, 63, 145, 0, 22, 63, 145, 0, 5, 145, 63
	db 26, 145, 0, 4, 145, 7, 25, 16, 0, 0
windowTitle db "ASCII Madness",0
write SMALL_RECT <0,0,MAXSCREENX-1,MAXSCREENY-1>
bmpSmallIcon	db MAXSCREENX*MAXSCREENY dup (?)
palette CHAR_INFO 64 dup (<>)   ;64*(2+2+1)=320=140h
chars CHAR_INFO 80*50 dup (<>);Character buffer
end